SUBROUTINE getposcar(NATOMTOT,SSZ,NATOM,NTYPEATOM,MASS,MATR,RECGITTER,MASSUB,basis,RS,NMASS)
        !This routine returns the following:
        ! 1) The lattice vectors of the supercell stored in the columns of: MATR
        ! 2) The reciprocal lattice vectors (of the primitive cell ) stored in
        !    the columns of RECGITTER
        ! 3) The mass of the atoms beloning to a specific subgitter stored in
        !    the array: MASSUB
        ! 4) The positions of the atoms in the primitive cell (direct
        !    coordinates) stored in the rows of the matrix: basis.
        ! 5) The positions of the atoms in the POSCAR file (Direct coordinates)
        !    stored in the rows of the matrix: RS
        IMPLICIT NONE
        EXTERNAL :: invert
        INTEGER, INTENT(IN) :: NATOMTOT,SSZ(3),NATOM,NTYPEATOM
        DOUBLE PRECISION, INTENT(IN)  :: MASS(10)
        DOUBLE PRECISION, INTENT(INOUT) :: MATR(3,3),RECGITTER(3,3)
        DOUBLE PRECISION, INTENT(OUT) :: MASSUB(NATOM),basis(NATOM,3),RS(NATOMTOT,3)
        INTEGER, INTENT(OUT) :: NMASS(NTYPEATOM)
        CHARACTER(LEN=3) :: DUMMY
        INTEGER :: i,j,l,NSUB,jm
        DOUBLE PRECISION :: MATR2(3,3)
        
        OPEN(10,FILE='POSCAR',STATUS='OLD',ACTION='READ')
        READ(10,*) DUMMY
        READ(10,*) DUMMY
        READ(10,*) MATR(1,1),MATR(1,2),MATR(1,3)
        READ(10,*) MATR(2,1),MATR(2,2),MATR(2,3)
        READ(10,*) MATR(3,1),MATR(3,2),MATR(3,3)
        READ(10,*) NMASS
        READ(10,*) DUMMY
        DO j=1,NATOMTOT
                READ(10,*) RS(j,1),RS(j,2),RS(j,3)
        ENDDO
        close(10)
        
        NSUB = SSZ(1)*SSZ(2)*SSZ(3)
        
        ! Here the masses of the different atom types are put into
        ! the array MASSUB
        jm = 0
        DO i=1,NTYPEATOM
                j= NMASS(i)/NSUB
                DO l=1,j
                        MASSUB(l+jm) = MASS(i)
                ENDDO
                jm = jm+j
        ENDDO
        ! Here the lattice vectors of the supercell are put into columns

        MATR = TRANSPOSE(MATR)

        ! Here the reciprocal lattice vectors are calculated:

        MATR2(:,1) = MATR(:,1)/(1.0d0*SSZ(1))
        MATR2(:,2) = MATR(:,2)/(1.0d0*SSZ(2))
        MATR2(:,3) = MATR(:,3)/(1.0d0*SSZ(3))

        call invert(MATR2,RECGITTER)

        RECGITTER = TRANSPOSE(RECGITTER)

        ! Here the atomic positions (Direct coordinates) are 
        ! stored

        DO i=1,NATOM
                basis(i,:) = RS(1+(i-1)*NSUB,:)
        ENDDO
END SUBROUTINE getposcar
